//Copyright (c) 1999, Art Gittleman
//This example is provided WITHOUT ANY WARRANTY either expressed or implied.

/* Two threads occasionally err in reporting 
 * values because they get interrupted before 
 * finishing to execute a method.
 */

public class TallyWrong 
{
  class Buffer {          
    int number = 0;        // the number to increase or decrease
    int previous = 0;
    int total = 0;         // total number of operations performed
    int errors = 0;        // number of errors

    public void increment() {
      number++;
      report(number);
    }

    public void decrement() {
      number--;
      report(number);
    }

    public void report(int n) {
      total++;
      if (n == previous)
        System.out.println(++errors + "\t" + total 
                       + "\t" + Thread.currentThread().getName() );
      previous = n;
    }
  } // end Buffer Class

  class Plus extends Thread {
     Buffer buf;

     Plus(Buffer b) { 
       buf=b;
     }			

     public void run() {
       System.out.println("Starting Plus");
       while (true)
	 { 
          buf.increment();
         }
     }
  } // end Plus Class

  class Minus extends Thread 
  {
     Buffer buf;

     Minus(Buffer b) { 
       buf=b; 
     }
     public void run() { 
       System.out.println("Starting Minus");
       while (true)
	 { 
         if(buf.errors >20) System.exit(1);
         buf.decrement();
         }
     }
  } //end Minus Class

  public static void main(String[] argv) {
    TallyWrong tw = new TallyWrong();
    Buffer b = tw.new Buffer();
    Plus p = tw.new Plus(b);
    Minus m = tw.new Minus(b);
    p.start();
    m.start();
  }
}

